import { IndexDirection, IndexOptions, Schema, SchemaOptions, SchemaTypeOptions } from 'mongoose';
import { Constructor } from 'type-fest';
import { ActionType, HookType } from './middleware';
export type Fn = () => unknown;
export interface IIndexArgs {
    fields: Record<string, IndexDirection>;
    options?: IndexOptions;
}
export type IPluginType<T> = (schema: Schema, options?: T) => void;
export interface IPluginArgs<T> {
    plugin: IPluginType<T>;
    options?: T;
}
export declare class MongooseMeta {
    name: string;
    clazz: Function;
    schema: Record<string, SchemaTypeOptions<unknown>>;
    statics: {
        [name: string]: Fn;
    };
    methods: {
        [name: string]: Fn;
    };
    virtuals: {
        [name: string]: PropertyDescriptor;
    };
    queries: {
        [name: string]: Fn;
    };
    indexes: IIndexArgs[];
    middleware: Array<[ActionType, HookType, Fn]>;
    plugins: Array<IPluginArgs<unknown>>;
    options?: SchemaOptions;
}
export declare function setMongooseMeta(target: object, meta: Partial<MongooseMeta>): void;
export declare function getMongooseMeta(target: object): MongooseMeta;
export declare function hasMongooseMeta(target: object): target is Constructor<unknown>;
