"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasMongooseMeta = exports.getMongooseMeta = exports.setMongooseMeta = exports.MongooseMeta = void 0;
class MongooseMeta {
    name;
    // eslint-disable-next-line @typescript-eslint/ban-types
    clazz;
    schema = {};
    statics = {};
    methods = {};
    virtuals = {};
    queries = {};
    indexes = [];
    middleware = [];
    plugins = [];
    options = undefined;
}
exports.MongooseMeta = MongooseMeta;
const mongooseMeta = Symbol('MongooseMeta');
function setMongooseMeta(target, meta) {
    const exists = Reflect.getMetadata(mongooseMeta, target) ?? new MongooseMeta();
    Reflect.defineMetadata(mongooseMeta, { ...exists, ...meta }, target);
}
exports.setMongooseMeta = setMongooseMeta;
function getMongooseMeta(target) {
    const metadata = Reflect.getMetadata(mongooseMeta, target);
    if (metadata)
        return metadata;
    const meta = new MongooseMeta();
    Reflect.defineMetadata(mongooseMeta, meta, target);
    return meta;
}
exports.getMongooseMeta = getMongooseMeta;
function hasMongooseMeta(target) {
    return Reflect.hasMetadata(mongooseMeta, target);
}
exports.hasMongooseMeta = hasMongooseMeta;
//# sourceMappingURL=meta.js.map