"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.subModel = exports.index = exports.model = void 0;
const meta_1 = require("./meta");
function model(name, options) {
    return (target) => {
        const meta = (0, meta_1.getMongooseMeta)(target.prototype);
        meta.name = name;
        meta.options = options;
        meta.clazz = target;
    };
}
exports.model = model;
function index(fields, options) {
    return (target) => {
        (0, meta_1.getMongooseMeta)(target.prototype).indexes
            .push({ fields, options });
    };
}
exports.index = index;
function subModel(options = {}) {
    return (target) => {
        const meta = (0, meta_1.getMongooseMeta)(target.prototype);
        if (options._id === undefined) {
            options._id = false;
        }
        if (options.name) {
            meta.name = options.name;
        }
        meta.options = options;
        meta.clazz = target.prototype;
    };
}
exports.subModel = subModel;
function plugin(plugin, options) {
    return (target) => {
        (0, meta_1.getMongooseMeta)(target.prototype).plugins
            .push({ plugin: plugin, options });
    };
}
exports.plugin = plugin;
//# sourceMappingURL=model.js.map