import { DefaultType, SchemaTypeOptions } from 'mongoose';
import { Class, Constructor } from 'type-fest';
export declare function prop<T>(options?: SchemaTypeOptions<T>, type?: SchemaTypeOptions<unknown>['type']): PropertyDecorator;
export declare function array<T extends Constructor<unknown> | Array<unknown>>(type: T, options?: SchemaTypeOptions<T[]>): (target: object, name: string) => void;
export declare function id(): PropertyDecorator;
export declare function required(): (target: object, name: string) => void;
export declare function indexed(): (target: object, name: string) => void;
export declare function hidden(): (target: object, name: string) => void;
export declare function unique(): (target: object, name: string) => void;
type DefaultsType = DefaultType<unknown> | (() => DefaultType<unknown>);
export declare function defaults<T extends DefaultsType>(value: T | null | undefined): (target: object, name: string) => void;
export declare function type(type: Constructor<unknown>): (target: object, name: string) => void;
type EnumValue = string | number | null;
export declare function enums<T extends EnumValue>(values: Array<T> | Record<string | number, T>, allowNull?: boolean): (target: object, name: string) => void;
type LazyClass = () => Constructor<unknown>;
export declare function ref(nameOrClass: string | LazyClass, idType: unknown): (target: object, name: string) => void;
export declare function ref(nameOrClass: Constructor<unknown>, idType?: unknown): (target: object, name: string) => void;
export declare function refArray(nameOrClass: string | LazyClass | Constructor<unknown>, elementType: unknown): (target: object, name: string) => void;
/** @deprecated can be auto loaded */
export declare function statics(): (target: Class<unknown>, name: string, descriptor: PropertyDescriptor) => void;
export declare function query(): (target: object, name: string, descriptor: PropertyDescriptor) => void;
/** @deprecated can be auto loaded */
export declare function methods(): (target: object, name: string, descriptor: PropertyDescriptor) => void;
/** @deprecated can be auto loaded */
export declare function virtual(): (target: object, name: string, descriptor: PropertyDescriptor) => void;
export declare function mongoId<T>(options?: SchemaTypeOptions<T>, type?: T): PropertyDecorator;
export {};
